.386
.model flat,stdcall
option casemap:none
WinMain proto :DWORD,:DWORD,:DWORD,:DWORD
DlgboxProc proto :DWORD,:DWORD,:DWORD, :DWORD

include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\kernel32.inc
include \masm32\include\comctl32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\comctl32.lib

.data
ClassName db "SimpleWinClass",0
AppName  db "Progress Bar",0
progressBar db "msctls_progress32",0
MenuName db "FirstMenu",0
DlgboxName db "MyDialogbox",0
Message		db "Finished!",0
myBuffer1 db 30 DUP (0)

.data?
hInstance HINSTANCE ?
CommandLine LPSTR ?
hMenu HMENU ?
hProgressBar DWORD ?
hTimer DWORD ?
lastError DWORD ?
nCurrentStep DWORD ?

.const
IDM_PROGRESS equ 1000
IDM_EXIT equ 1001

DLI_PROGRESS equ 4000
DLI_OK equ 4001

IDC_TIMER equ 2001

.code
start:
	invoke GetModuleHandle, NULL
	mov    hInstance,eax
	invoke GetCommandLine
	invoke WinMain, hInstance,NULL,CommandLine, SW_SHOWDEFAULT
	invoke ExitProcess,eax
WinMain proc hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
	LOCAL wc:WNDCLASSEX
	LOCAL msg:MSG
	LOCAL hwnd:HWND
	mov   wc.cbSize,SIZEOF WNDCLASSEX
	mov   wc.style, CS_HREDRAW or CS_VREDRAW
	mov   wc.lpfnWndProc, OFFSET WndProc
	mov   wc.cbClsExtra,NULL
	mov   wc.cbWndExtra,NULL
	push  hInst
	pop   wc.hInstance
	mov   wc.hbrBackground,COLOR_WINDOW+1
	mov   wc.lpszMenuName,OFFSET MenuName
	mov   wc.lpszClassName,OFFSET ClassName
	invoke LoadIcon,NULL,IDI_APPLICATION
	mov   wc.hIcon,eax
	mov   wc.hIconSm,0
	invoke LoadCursor,NULL,IDC_ARROW
	mov   wc.hCursor,eax
	invoke RegisterClassEx, addr wc
	INVOKE CreateWindowEx,NULL,ADDR ClassName,ADDR AppName,\
           WS_OVERLAPPEDWINDOW,30,\
           30,400,400,NULL,NULL,\
           hInst,NULL
	mov   hwnd,eax
	INVOKE ShowWindow, hwnd,SW_SHOWNORMAL
	INVOKE UpdateWindow, hwnd
	.WHILE TRUE
                INVOKE GetMessage, ADDR msg,NULL,0,0
                .BREAK .IF (!eax)
                INVOKE DispatchMessage, ADDR msg
	.ENDW
	mov     eax,msg.wParam
	ret
WinMain endp

WndProc proc hWnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM
	LOCAL rect:RECT
	LOCAL hdc:HDC
	LOCAL ps:PAINTSTRUCT
	.IF uMsg==WM_DESTROY
		invoke PostQuitMessage,NULL
	.ELSEIF uMsg==WM_CREATE
		invoke InitCommonControls
	.ELSEIF uMsg==WM_COMMAND
		mov eax,wParam
		.IF ax==IDM_PROGRESS
			invoke CreateDialogParam,hInstance, addr DlgboxName,hWnd,OFFSET DlgboxProc,NULL
		
		.ELSE
			invoke DestroyWindow,hWnd
		.ENDIF
	.ELSE
		invoke DefWindowProc,hWnd,uMsg,wParam,lParam
		ret
	.ENDIF
	xor    eax,eax
	ret
WndProc endp

DlgboxProc proc hDlg:HWND,iMsg:DWORD,wParam:WPARAM, lParam:LPARAM
        .if iMsg==WM_INITDIALOG
		invoke CreateWindowEx, NULL, ADDR progressBar, NULL,  WS_CHILD or WS_VISIBLE,\
			20, 80, 200, 16, hDlg,IDC_TIMER,\
			hInstance, NULL 
		mov hProgressBar, eax
		mov eax,1000
		mov nCurrentStep,eax
		shl eax,16
		invoke SendMessage,hProgressBar,PBM_SETRANGE,0,eax
		invoke SendMessage,hProgressBar,PBM_SETSTEP,10,0
		invoke SetTimer,hDlg,IDC_TIMER,100,NULL
		mov hTimer,eax
	.elseif iMsg==WM_TIMER
		invoke SendMessage,hProgressBar,PBM_STEPIT,0,0
		sub nCurrentStep,10
		.if nCurrentStep==0
			invoke KillTimer,hDlg,IDC_TIMER		

			mov hTimer,0
			;invoke SendMessage,hWndStatus,SB_SETTEXT,0,addr Message
			;invoke MessageBox,hDlg,addr Message,addr AppName,MB_OK+MB_ICONINFORMATION
			;invoke SendMessage,hWndStatus,SB_SETTEXT,0,0
			invoke SendMessage,hProgressBar,PBM_SETPOS,0,0
		.endif
        .elseif iMsg==WM_COMMAND
		mov eax,wParam
		.if ax==DLI_OK
			invoke EndDialog, hDlg, 0 
		.endif
	.else
		mov eax,FALSE
		ret
	.endif
        mov  eax,TRUE
        ret

DlgboxProc endp

end start
